#ifndef FILTERD_H
#define FILTERD_H

#include "filter_types.h"
#include "filter_control.h"
#include "iri_iif_req.h"
#include "../ini3d/ini3d.h"
#include "sdm_req_queue.h"

#include "iri_iif/itc2.h"

#define INTERCEPT_ADD    0
#define INTERCEPT_REMOVE 1
#define NO_INTERCEPT -1
#define TRAP_IN_TIMEOUT 5000
#define SDM_BUFFER_SIZE 24

#define ETH_IP4   0x0800
#define ETH_IP6   0x86DD
#define ETH_VLAN  0x8100
#define PROTO_TCP 0x06
#define PROTO_UDP 0x11

typedef struct report_args_s {
    uint8_t thr_id;
    const char *pcap_dev;
    filter_table_t *filter;
    sdm_q_t *sdm_req;
    uint8_t *ext_headers;
    int iri_iif_socket;
    itc_ptr interface_for_controller;
    itc_ptr interface_for_adb;
} report_args_t;

typedef struct manager_args_s {
    iri_iif_queue_t *q_array;
    filter_table_t *filter;
    uint8_t reporter_count; 
    sdm_q_t *sdm_req;
    itc_ptr interface_to_controller;
} manager_args_t;

#endif
