/*
 * Soubor:  iri-iif-controller.h
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IRI-IIF pro SDM
 * Popis:   hlavickovy soubor pro funkce tvorici rozhrani mezi CC-IIF a IRI-IIF
 *          a funkce vykonavajici cinnost IRI-IIF kontroleru
 */

#ifndef _IRI_IIF_CONTROLLER_
#define _IRI_IIF_CONTROLLER_

#include "header-files.h"

/*
 * funkce pro otevreni TCP spojeni s MF ktere se budou zasilat vytvorene zpravy IRI
 */
int iri_iif_open_socket_to_iri_core(void);

/*
 * inicializacni funkce kterou je nutno zavolat po vytvoreni vlakna pred zpracovanim prvniho paketu
 * @param int hodnota urcujici velikost hashovaci tabulky
 * @param int socket na ktery se budou zasilat vysledne zpravy IRI
 * @param itc_ptr rozhrani pro spravu ADB ze strany filtr demona
 * @param itc_ptr rozhrani pro spravu ADB ze strany komponenty sprava ADB
 * @return int hodnota urcujici uspesnost inicializace
 */
int iri_iif_init(int hash_table_size, int iri_iif_socket, itc_ptr interface_to_filterd, itc_ptr interface_for_adb, int input_threadId);

/*
 * funkce pro zpracovani noveho paketu
 * @param flow_identifier_t * ukazatel na strukturu obsahujici predpocitane hodnoty hash a klic ze ktereho byly pocitany
 * @param offsets_t * ukazatel na strukturu predpocitanych offsetu
 * @param ini3payload_t * ukazatel na strukturu obsahujici hlavicku load_head_t a payload paketu
 * @return int hodnota urcujici zda je o tok zajem. 0 znamena filtrovat a 1 ze je zajem tok zpracovavat
 */
int iri_iif_process_new_packet(flow_identifier_t *, offsets_t *offsets,  ini3payload_t *packet);


void iri_iif_destroy();


#endif
