
#ifndef _IRI_IIF_HASH_TABLE_
#define _IRI_IIF_HASH_TABLE_


#include "header-files.h"

typedef struct iri_iif_hash_table_additional_data
{
////////////////////////////////////////////////// blok packet buffer //////////////////////////////////////////////////
	unsigned int pb_storedBytes; // sucet alokovaneho miesta ulozenych paketov v ADB
///////////////////////////////////////////////////// blok modules /////////////////////////////////////////////////////
	unsigned short int modules_vector2; // bitovy vektor modulov (ma/nema zaujem)
	void *modules_data[MODULE_COUNT]; // ukazatele na struktury kde si moduly ukladaju data
	unsigned short int modules_waitingForReplies; // pocet modulu kere este cekaju na odpoved
/////////////////////////////////////////////////////// blok ADB ///////////////////////////////////////////////////////
	char adb_store; // urcuje ci sa maju pakety v tomto toku ukldat do ADB
	struct packetBufferItem * adb_first; // ukazatel na prvy ADB paket v danom toku
	struct packetBufferItem * adb_last; // ukazatel na posledny ADB paket v danom toku
/////////////////////////////////////////////////// TCP reassembling ///////////////////////////////////////////////////
	// vacsi smer
	uint32_t tcpr_seqNumB; // sekvencne cislo dalsieho paketu v poradi
	struct packetBufferItem * tcpr_firstPacketB; // ukazatel na prvy ulozeny paket
	struct packetBufferItem * tcpr_lastPacketB; // ukazatel na posledny ulozeny paket
	char tcpr_stateB; // aktualny stav reassemblingu v danem toku
	uint32_t tcpr_timestampSecB; // cas prveho paketu prijateho pri detekovani diery
	// mensi smer
	uint32_t tcpr_seqNumS; // sekvencne cislo dalsieho paketu v poradi
	struct packetBufferItem * tcpr_firstPacketS; // ukazatel na prvy ulozeny paket
	struct packetBufferItem * tcpr_lastPacketS; // ukazatel na posledny ulozeny paket
	char tcpr_stateS; // aktualny stav reassemblingu v danem toku
	uint32_t tcpr_timestampSecS; // cas prveho paketu prijateho pri detekovani diery
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
} iri_iif_hash_table_additional_data_t;


typedef struct iri_iif_hash_table_item
{
	item_key_t key; // kluc na zaklade ktoreho sa vyhladava v tabulke
	uint32_t timeLastPacket; // cas prijatia posledneho paketu v ramci toku
	uint32_t timeDelete; // od tohto casu bude mozne uplne zmazat zaznam (faza 2)
	iri_iif_hash_table_additional_data_t *additionalData; // data jednotlivych blokov modulov
} iri_iif_hash_table_item_t;


int iri_iif_hash_table_init( int, int );
iri_iif_hash_table_item_t *iri_iif_find_flow_record( item_key_t * );
iri_iif_hash_table_item_t * iri_iif_hash_table_find_or_create_record( flow_identifier_t * , unsigned short int );
void iri_iif_hash_table_destroy_record_phase_1( iri_iif_hash_table_item_t * , char);
void iri_iif_hash_table_destroy_record_phase_2( iri_iif_hash_table_item_t * );
void iri_iif_hash_table_print( );
void iri_iif_hash_table_destroy( );
void iri_iif_hash_table_clean_up( uint32_t );
#endif
