/*
 * Soubor:  detekce_protokolu.h
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IM modul pro SDM
 * Popis:   hlavickovy soubor pro funkci ktera analyzuje prijaty paket a vrati zjistene udaje.
 */

#ifndef _DETEKCE_PROTOKOLU_
#define _DETEKCE_PROTOKOLU_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pcap.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
// ethernetová hlavicka
#include <net/ethernet.h>
// ipv4
#include <netinet/ip.h>
// ipv6
#include <netinet/ip6.h>
#include <netinet/tcp.h>

#include <pcap/bpf.h>
#include <pcap/sll.h>

#include "../iri-iif-shared.h"

#include "my_string.h"
#include "xmpp.h"
#include "irc.h"
#include "oscar.h"
#include "zpracovany_packet.h"

#define IPV6_LENGTH 40
#define IPV6_EXT_LENGTH 8

struct data_packetu ziskej_obsah(iri_iif_offsets_t *offsets, ini3payload_t *packet);
int podle_portu(iri_iif_offsets_t *offsets, ini3payload_t *packet);
void ip_verze_4(iri_iif_offsets_t *offsets, ini3payload_t *packet, struct data_packetu *vyfiltrovano_z_packetu);
void ip_verze_6(iri_iif_offsets_t *offsets, ini3payload_t *packet, struct data_packetu *vyfiltrovano_z_packetu);
void tcp(iri_iif_offsets_t *offsets, ini3payload_t *packet, struct data_packetu *vyfiltrovano_z_packetu);
#endif
