/*
 * Soubor:  sprava.c
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IM modul pro SDM
 * Popis:   soubor obsahujici funkce pro spravu sezeni
 */

//#include "xmpp.h"
#include "sprava.h"



/*
 * inicializace struktury noveho sezeni
 */
void inicializace_sezeni(struct sezeni *Sezeni)
{
	Sezeni->aktivni = 0;
	Sezeni->uzivatel_pripojen.tv_sec = 0;
	Sezeni->uzivatel_pripojen.tv_usec = 0;
	Sezeni->transportni_protokol = 0; 
	Sezeni->typ_ip = 0;
	Sezeni->ipv4_adresa.s_addr = 0;
	Sezeni->ipv4_adresa_2.s_addr = 0;
	for(int i = 0; i < 16; i++){
		Sezeni->ipv6_adresa.s6_addr[i] = 0;
		Sezeni->ipv6_adresa_2.s6_addr[i] = 0;
	}
	Sezeni->port = 0;
	Sezeni->port_2 = 0;
	Sezeni->protokol = NEZNAME;
	Sezeni->ID_uzivatele = NULL;
	Sezeni->server = NULL;
	Sezeni->aktualni_stav = 0; // nepripojen
	Sezeni->potreba_dokoncit_prichozi = NULL;
	Sezeni->ocekavat_dalsi_prichozi = 0;
	Sezeni->potreba_dokoncit_odchozi = NULL;
	Sezeni->ocekavat_dalsi_odchozi = 0;
	Sezeni->ukonceno = 0;
}

/*
 * vymaze alokovane polozky v seznamu sezeni
 */
void smazani_sezeni(struct sezeni *Sezeni)
{
	if(Sezeni->ID_uzivatele != NULL)
	{
		free(Sezeni->ID_uzivatele);
	}
	if(Sezeni->server != NULL)
	{
		free(Sezeni->server);
	}
	if(Sezeni->potreba_dokoncit_prichozi != NULL)
	{
		free(Sezeni->potreba_dokoncit_prichozi);
	}
	if(Sezeni->potreba_dokoncit_odchozi != NULL)
	{
		free(Sezeni->potreba_dokoncit_odchozi);
	}
}




