/*
 * Soubor:  sprava.h
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IM modul pro SDM
 * Popis:   hlavickovy soubor pro funkce pro spravu sezeni
 */

#ifndef _SPRAVA_
#define _SPRAVA_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>
#include <fcntl.h>
#include <time.h> 

#include "my_string.h"
#include "zpracovany_packet.h"


struct sezeni
{
	int aktivni;
	struct timeval uzivatel_pripojen;
	int transportni_protokol;
	int typ_ip;
	struct in_addr ipv4_adresa;
	struct in_addr ipv4_adresa_2;
	struct in6_addr ipv6_adresa;
	struct in6_addr ipv6_adresa_2;
	int port;
	int port_2;
	int protokol;
	char *ID_uzivatele;
	char *server; // pro irc
	int aktualni_stav;
	char *potreba_dokoncit_prichozi;
	int ocekavat_dalsi_prichozi;
	char *potreba_dokoncit_odchozi;
	int ocekavat_dalsi_odchozi;
	int ukonceno;
};



void inicializace_sezeni(struct sezeni *Sezeni);
void smazani_sezeni(struct sezeni *Sezeni);


#endif
