
#ifndef _IRI_IIF_MODULES_
#define _IRI_IIF_MODULES_

#include "header-files.h"

// obsahuje include prikazy pre includovanie hlavickovych suborov povolenych modulov
#include "configs/modules-includes.include"

// navratove hodnoty od modulov
#define MODULE_WANTS_TO_ANALYZE_THIS_FLOW	0
#define MODULE_WANTS_TO_FILTER_THIS_FLOW	1

// specialna hodnota vektoru modulov ked nikdo nema zaujem o tok
#define NOBODY_WANTS_TO_ANALYZE_THIS_FLOW	0


typedef struct modulesIriMessages
{
	char * message; // ulozena sprava
	unsigned int length; // dlzka spravy
	struct modulesIriMessages * next;
}* modulesIriMessages_ptr;


void iri_iif_modules_init( int );
int iri_iif_modules_open_socket_to_iri_core();
int iri_iif_modules_reopen_socket_to_iri_core();
int iri_iif_modules_send_packet( iri_iif_hash_table_item_t *, iri_iif_offsets_t *, ini3payload_t * );
void iri_iif_modules_notice_end_of_flow( iri_iif_hash_table_item_t * );
void iri_iif_modules_send_iri_message( const char* , char, iri_iif_hash_table_item_t*, char);
void iri_iif_modules_destroy( iri_iif_hash_table_item_t * );
void iri_iif_modules_check_iri_message_buffer( );

typedef int (*module_process_packet_function_t) (iri_iif_hash_table_item_t *, iri_iif_offsets_t *, unsigned char *, uint16_t, void *);
typedef void (*module_process_end_of_flow_function_t) (iri_iif_hash_table_item_t *, void *);
typedef int (*module_destroy_data_function_t) (iri_iif_hash_table_item_t *, void *);

#endif
