#ifndef _IRI_IIF_MODULE_SIP_
#define _IRI_IIF_MODULE_SIP_


#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <net/ethernet.h>
#include <netinet/udp.h>
#include <stdbool.h>
#include <time.h>

#include <sys/socket.h>
#include <sys/un.h>

#include "../header-files.h"

// IPv6 addr length (39B) + '\0' + some padding
#define ADDRESS_SIZE 64

typedef enum {
  NO_IRI_SENT = 0,
  IRI_THREE_SENT,
  IRI_BEGIN_SENT,
  IRI_END_SENT
} IRIstatusType;

typedef enum {
  NO_METHOD = 0,
  REQUEST_REGISTER,
  REQUEST_INVITE,
  REQUEST_ACK,
  REQUEST_CANCEL,
  REQUEST_BYE,
  REQUEST_OPTIONS,
  REQUEST_SUBSCRIBE,
  REQUEST_NOTIFY,
  REQUEST_PUBLISH,
  REQUEST_PRACK,
  REQUEST_UNREGISTER,
  RESPONSE_SESSION_PROGRESS,
  RESPONSE_PROVISIONAL,
  RESPONSE_SUCCESS,
  RESPONSE_REDIRECTION,
  RESPONSE_ERROR
} methodType;

typedef struct transactionInfo{
  char * uri2;
  char * callId;
  short unsigned int sequenceNumber;
  methodType method;
  methodType status;
  bool waitForAck;
  struct transactionInfo * next;
} transactionInfo;

typedef struct userInfoPtr{
  char * ipAddress1;
  char * ipAddress2;
  char * sipUri1;
  char * sipUri2;
  short unsigned int rtpPort1[5];
  short unsigned int rtpPort2[5];
  IRIstatusType registerStatus;
  IRIstatusType callStatus;
  transactionInfo * transactions;
} * userInfoPtr;

int new_sip_destroy_data(iri_iif_hash_table_item_t *table_item, void * data);
int new_sip_process_packet(iri_iif_hash_table_item_t *table_item, iri_iif_offsets_t *offsets, unsigned char *packet, uint16_t packet_size,  void * input_dataPointer);

#endif
