#ifndef _IRI_IIF_PACKET_BUFFER_
#define _IRI_IIF_PACKET_BUFFER_

#include "header-files.h"

// velkost pre ukladanie paketov
#define AMOUNT_OF_THE_PACKETS 500
#define DEFAULT_PACKET_SIZE 1600


typedef struct packetBufferItem
{
	struct packetBufferItem * prev;
	struct packetBufferItem * next;
	item_key_t key; // kluc na zaklade ktoreho sa vyhladava tok v hash tabulke
	iri_iif_offsets_t offsets; // offsety daneho paketu
	ini3payload_t packet; // obsah paketu aj s SZE hlavickou
	char uses; // pocet blokov ktore maju dany packet ulozeny
	///////////////////////////////////////////////////// blok ADB /////////////////////////////////////////////////////
	char  adb_inUse; // premenna na zaklade ktorej system urcuje ci sa dany paket pouziva v ADB
	struct packetBufferItem *  adb_next; // ukazatel na dalsi AB paket
	///////////////////////////////////////////////// TCP reassembling /////////////////////////////////////////////////
	char  tcpr_inUse; // premenna na zaklade ktorej system urcuje ci sa dany paket pouziva v TCPr
	uint32_t tcpr_seqNum; // sekvencne cislo ulozeneho paketu
	uint32_t tcpr_seqNumNext; // sekvencne cislo dalsieho ulozeneho paketu v poradi
	struct packetBufferItem * tcpr_prev; // ukazatel na predosly ulozeny paket
	struct packetBufferItem * tcpr_next; // ukazatel na dalsi ulozeny paket
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}* packetBufferItem_ptr;


typedef struct packetBuffer
{
	packetBufferItem_ptr first; // ukazatel na prvy (najstarsi) pouzity paket
	packetBufferItem_ptr last; // ukazatel na posledny pouzity paket
}* packetBuffer_ptr;

typedef struct packetFreeBuffer
{
	packetBufferItem_ptr last; // ukazatel na posledny volny paket (zasobnik)
	unsigned int length; // pocet volnych prvkov
}* packetFreeBuffer_ptr;


void iri_iif_packet_buffer_delete_cache();
void iri_iif_packet_buffer_update_cache( packetBufferItem_ptr );
int iri_iif_packet_buffer_init();
void iri_iif_packet_buffer_destroy();
int iri_iif_packet_buffer_packet_save(iri_iif_hash_table_item_t *, iri_iif_offsets_t *, ini3payload_t *, packetBufferItem_ptr * );
int iri_iif_packet_buffer_packet_free( iri_iif_hash_table_item_t *, packetBufferItem_ptr );
void iri_iif_packet_buffer_print();
void iri_iif_packet_buffer_big_flow( iri_iif_hash_table_item_t * );

#endif
