/*
 * Soubor:  iri-iif-shared.h
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IRI-IIF pro SDM
 * Popis:   hlavickovy soubor obsahujici definice sdilenych datovych struktur
 */

#ifndef _IRI_IIF_SHARED_
#define _IRI_IIF_SHARED_

#include "header-files.h"

// zapnutie debugovania
#define IRI_IIF_DEBUG				1 // zapne debugovanie vsade
#define IRI_IIF_DEBUG_ADB			0
#define IRI_IIF_DEBUG_CONTROLLER		0
#define IRI_IIF_DEBUG_FILTER			0
#define IRI_IIF_DEBUG_HASH_TABLE		0
#define IRI_IIF_DEBUG_MODULES			0
#define IRI_IIF_DEBUG_PACKET_BUFFER		0
#define IRI_IIF_DEBUG_TCP_REASSEMBLING		0
#define IRI_IIF_DEBUG_APP_MODULES		0 // aplikacne moduly
#define IRI_IIF_DEBUG_COMMUNICATION		0 // komunikacia s IRI-core a filterd

// navratove hodnoty do filterd po spracovani paketu
#define RETAIN_FLOW 1
#define BLOCK_FLOW  0

// pomocne hodnoty pre ciselne premenne
#define TRUE 1
#define FALSE 0

// identifikatory protokolov
#define ICMP_PROTOCOL 1
#define IGMP_PROTOCOL 2
#define TCP_PROTOCOL 6
#define UDP_PROTOCOL 17

// ticket #244: zmazat ked bude ukazatel na aplikacne data posielat filterd:
#define UDP_LENGTH_OFFSET 4
#define UDP_HEADER_LENGTH 8

#include "configs/shared-defines.include"

// vseobecne navratove hodnoty
#define IRI_IIF_RETURN_OK				0
#define IRI_IIF_RETURN_MALLOC_ERROR		1
#define IRI_IIF_RETURN_NO_SPACE 		2
#define IRI_IIF_RETURN_GENERAL_ERROR 	255

typedef struct iri_iif_offsets
{
    uint8_t ip_ver; /**< IP version.*/
    uint8_t iph_start; /**< Start of L3 header. */
    uint8_t ip_start; /**< Start of source ip address. */
    uint8_t l4_start; /**< Start of L4 header. */
    uint8_t protocol; /**< L4 protocol offset. */
	
	unsigned int data_offset;
	unsigned int data_length;
} iri_iif_offsets_t;

typedef struct flow_identifier
{
	item_key_t *key;
} flow_identifier_t;

typedef struct intercept_identifier
{
	uint32_t rid;
	item_key_t key;
} intercept_identifier_t;


#endif

