#ifndef _IRI_IIF_MODULE_SMTP_
#define _IRI_IIF_MODULE_SMTP_

#include <pcap.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "../header-files.h"

#define TRAFFIC_FROM_SERVER 0
#define TRAFFIC_FROM_CLIENT 1


typedef struct { // struktura pre predavanie informacii rozparsovaneho paketu
    unsigned int srcIp;
    unsigned int dstIp;
    unsigned int srcPort;
    unsigned int dstPort;
    unsigned int seqNum;
    unsigned int ackNum;
    unsigned int flags;
    unsigned int data;
} parser;

typedef struct ack { 
    unsigned int value;
    struct ack *next;
} *ack_ptr;

typedef struct email { 
    unsigned short int length;
    char *emailString;
    unsigned int ackNum;
    char confirmed;
    struct email *next;
} *email_ptr;

typedef struct iri_iif_module_smtp_data { // struktura do ktorej sa budu ukladat data modulu (na strukturu bude odkazovane z SDM)
    char state;
    char clientServer;
    struct email *mail;
    struct email *rcpts;
    struct ack *acks;
} *iri_iif_module_smtp_data_ptr;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// nasledujuce data budu vo finalnej verzii implementovane v SDM, t.j. v tomto programe na ne nie je kladeny doraz na optimalizaciu

typedef struct moduleData { 
    char moduleId;
    void * data;
    struct moduleData *next;
} *moduleData_ptr;

typedef struct connection { 
    char ipType;
    char *clientIp;
    char *serverIp;
    char *clientPort;
    char *serverPort;
    
    char state;
    struct email *mail;
    struct email *rcpts;
    struct ack *acks;
    
    moduleData_ptr modules;
    
    struct connection *next;
} *connection_ptr;

typedef struct {
    connection_ptr first;
    connection_ptr temp;
    unsigned int count;
} connections;

//void smtp_init(int socket);

int smtp_process_packet(iri_iif_hash_table_item_t *table_item, iri_iif_offsets_t *offsets, unsigned char *packet, uint16_t packet_size, void * data);

int smtp_destroy_data( iri_iif_hash_table_item_t *table_item, void * data );

void smtp_process_end_of_flow( iri_iif_hash_table_item_t *table_item, void * data );

#endif
