/*
 * Soubor:  iri-iif-tcp-reassembling.h
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IRI-IIF pro SDM
 * Popis:   hlavickovy soubor pro funkce pro skladani TCP toku
 */

#ifndef _IRI_IIF_TCP_REASSEMBLING_
#define _IRI_IIF_TCP_REASSEMBLING_

#include "header-files.h"

//#define TCP_REASSEMBLING_IN_ORDER		0
//#define TCP_REASSEMBLING_HOLE_FILLED	1
//#define TCP_REASSEMBLING_NOT_IN_ORDER	2

#define TCP_REASSEMBLING_SEND_TO_MODULES		0
#define TCP_REASSEMBLING_DONT_SEND_TO_MODULES	1
#define TCP_REASSEMBLING_END_OF_THE_FLOW		2

/*
#define IN_ORDER 0
#define HOLE_FILLED 1
#define BUFFERED 2
#define DROPPED 3
#define FIN 4
*/
#define TCP_SEQ_NUM_OFFSET 4

#define FLOW_DIRECTION_SMALLER 1
#define FLOW_DIRECTION_BIGGER 2


#define TCP_STATE_INIT 0
#define TCP_STATE_SYN 1
#define TCP_STATE_SYN_ACK 2
#define TCP_STATE_EST 3
#define TCP_STATE_RST 4
#define TCP_STATE_FIN 5
#define TCP_STATE_CLS 6


#define	TCP_STATE_INIT 0
#define TCP_STATE_HANDSHAKE_NOT_FINISHED 2
#define TCP_STATE_BOTH_SEQ_VALID 3
//#define TCP_STATE_SMALLER_SIDE_CLOSED 4
//#define TCP_STATE_BIGGER_SIDE_CLOSED 5
#define TCP_STATE_CLOSED 6
#define TCP_STATE_THIS_SIDE_CLOSED 7
#define TCP_STATE_OTHER_SIDE_CLOSED 8

#include "configs/tcpreassembling-defines.include"


char iri_iif_tcp_reassembling_process_new_packet( iri_iif_hash_table_item_t *, iri_iif_offsets_t *, ini3payload_t **, struct packetBufferItem **, char * );

char iri_iif_tcp_reassembling_check_for_more_packets( iri_iif_hash_table_item_t *, iri_iif_offsets_t *, ini3payload_t **, struct packetBufferItem **, char );

void iri_iif_tcp_reassembling_save_packet( iri_iif_hash_table_item_t *, iri_iif_offsets_t *, ini3payload_t *, struct packetBufferItem ** , struct packetBufferItem ** , uint32_t * , uint32_t  );

void iri_iif_tcp_reassembling_free(iri_iif_hash_table_item_t * );

void iri_iif_tcp_reassembling_delete_first_n_packets_from_flow( iri_iif_hash_table_item_t * , unsigned int  );

void iri_iif_tcp_reassembling_send_data_with_gaps( iri_iif_hash_table_item_t *  );
/*
 * funkce volana IRI-IIF kontrolerem po prijeti noveho TCP paketu
 * @param flows_hash_table_item_t * ukazatel na zaznam toku do ktereho zpracovavany paket patri
 * @param iri_iif_offsets_t * ukazatel na strukturu obsahujici offsety v paketu
 * @param ini3payload_t * ukazatel na zpracovavany paket
 * @return int priznak urcujici jak bylo s paketem nalozeno
 */
//int iri_iif_tcp_reassembling_process_new_packet(flows_hash_table_item_t *flow_record, iri_iif_offsets_t *offsets, ini3payload_t *packet_to_process);

/*
 * Funkce slouzici k ziskani paketu ulozenych v bufferu v pripade uzavreni diry v toku
 * @param flows_hash_table_item_t struktura se zaznamem zpracovavaneho toku
 * @return buffer_item_t * ukazalet na polozku v bufferu ke zpracovani (paket ktery je v poradi) nebo NULL pokud neni co zpracovat
 */
//buffer_item_t *iri_iif_tcp_reassembling_request_for_paket(flows_hash_table_item_t *flow_record);

/*
 * funkce pro odstraneni paketu z bufferu
 * @param flows_hash_table_item_t * ukazatel na zaznam zpracovavaneho toku
 * @param buffer_item_t * ukazatel na mazanou polozku bufferu
 */
//void remove_from_buffer(flows_hash_table_item_t *flow_record, buffer_item_t *packet_from_buffer);

/*
 * Uvolneni pameti alokovane bufferem
 * @param buffer_t * ukazatel na uvolnovany buffer
 */
//void free_buffer(buffer_t *buffer);

#endif

