#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "itc2.h"
#include "itc2.c"

#define THREAD_COUNT		8
#define RECORDS_PER_CIRCLE	5
#define BYTES_PER_RECORD	10
#define NUMBER_OF_MESSAGES	100000
#define DELAY_WRITE			20
#define DELAY_READ			500

#include <pthread.h>

itc_ptr data;

void *threadFunc(void *arg)
{
	int threadId = atoi(arg);
	fprintf(stdout, "vlakno %d\n", threadId);
	char string[BYTES_PER_RECORD];
	int r;
	while(1)
	{
		r = rand() % DELAY_READ;
		usleep(r);
		while(itc_read(data, threadId, string))
		{
			if(strcmp(string, "END") == 0)
			{
				fflush(stdout);
				return NULL;
			}
			fprintf(stdout, "r%s\n", string);
		}
	}
}

int main(int argc, char *argv[])
{
	srand(time(NULL));
	int r, thread;
    unsigned int i;
	char string[BYTES_PER_RECORD];
    
    if( itc_init(&data, THREAD_COUNT, RECORDS_PER_CIRCLE, BYTES_PER_RECORD) )
	{
		itc_destroy(&data);
		return 1;
	}
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    
	pthread_t pth[THREAD_COUNT];	// this is our thread identifier
	char dig;
	char neco[3];
	
	for( i = 0; i < THREAD_COUNT; i++)
	{
		sprintf(neco, "%d", i);
		pthread_create(&pth[i], NULL, threadFunc, neco);
		usleep(100);
	}
	
	i = 0;
    
	while(i < NUMBER_OF_MESSAGES )
	{
		r = rand() % DELAY_WRITE;
		usleep(r);
		thread = rand() % THREAD_COUNT;
		sprintf(string, "%d: %.6d", thread, i);
		fprintf(stdout, "w%s\n", string);
		itc_write(data, thread, string);
		++i;
	}
	
    /*
    for(i = 0; i < 1000; i++)
        itc_write(data, 0, "BACKING UP");
    */
	for( i = 0; i < THREAD_COUNT; i++)
	{
		itc_write(data, i, "END");
	}
	
	usleep(20000);
	
	for( i = 0; i < THREAD_COUNT; i++)
	{
		pthread_cancel(pth[i]);
	}
	
	fflush(stdout);
	//fflush(stderr);
	
	
	/*
	itc_destroy(&data);
	pthread_cancel(pth);
	return 0;
    */
	///////////////////////////////////////////////////////////////////////////////////////////////
	/*
    while(itc_read(data, 0, string)) printf("%s\n", string);
    while(itc_read(data, 0, string)) printf("%s\n", string);
    vardump(data);
    itc_write(data, 0, "string 1");
    itc_write(data, 0, "string 1");
    itc_write(data, 0, "string 1");
    itc_write(data, 0, "string 1");
    itc_write(data, 0, "string 1");
    itc_write(data, 0, "string 1");
    vardump(data);
    while(itc_read(data, 0, string)) printf("%s\n", string);
    vardump(data);
    */
	/*
    printf("%d\n", __LINE__);vardump(data);
	itc_write(data, 0, "string 1");
	itc_write(data, 0, "string 2");
	itc_write(data, 0, "string 3");
    printf("%d\n", __LINE__);vardump(data);
	itc_write(data, 0, "string 4");
	itc_write(data, 0, "string 5");
	itc_write(data, 0, "string 6");
    printf("%d\n", __LINE__);vardump(data);
	itc_write(data, 0, "string 7");
	itc_write(data, 0, "string 8");
	itc_write(data, 0, "string 9");
	itc_write(data, 0, "string 10");
	itc_write(data, 0, "string 11");
	while(itc_read(data, 0, string)) printf("%s\n", string);
    printf("%d\n", __LINE__);vardump(data);
	
	itc_write(data, 0, "string 21");
	itc_write(data, 0, "string 22");
	itc_write(data, 0, "string 23");
	itc_write(data, 0, "string 24");
	itc_write(data, 0, "string 25");
	itc_write(data, 0, "string 26");
	itc_write(data, 0, "string 27");
	itc_write(data, 0, "string 28");
	itc_write(data, 0, "string 29");
	itc_write(data, 0, "string 30");
	itc_write(data, 0, "string 31");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	
	itc_destroy(&data); return 0;
    
	
	while(itc_read(data, 0, string)) printf("%s\n", string);
    printf("%d\n", __LINE__);vardump(data);
	itc_write(data, 0, "string 1");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	itc_write(data, 0, "string 2");
	itc_write(data, 0, "string 3");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	itc_write(data, 0, "string 4");
	itc_write(data, 0, "string 5");
	itc_write(data, 0, "string 6");
	itc_write(data, 0, "string 7");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	itc_write(data, 0, "string 8");
	itc_write(data, 0, "string 9");
	itc_write(data, 0, "string 10");
	itc_write(data, 0, "string 11");
	itc_write(data, 0, "string 12");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	itc_write(data, 0, "string 13");
	itc_write(data, 0, "string 14");
	itc_write(data, 0, "string 15");
	itc_write(data, 0, "string 16");
	itc_write(data, 0, "string 17");
    printf("%d\n", __LINE__);vardump(data);
	itc_write(data, 0, "string 18");
	itc_write(data, 0, "string 19");
	itc_write(data, 0, "string 20");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	itc_write(data, 0, "string 21");
	itc_write(data, 0, "string 22");
	itc_write(data, 0, "string 23");
	itc_write(data, 0, "string 24");
	itc_write(data, 0, "string 25");
	itc_write(data, 0, "string 26");
	itc_write(data, 0, "string 27");
	itc_write(data, 0, "string 28");
	itc_write(data, 0, "string 29");
	itc_write(data, 0, "string 30");
	itc_write(data, 0, "string 31");
	itc_write(data, 0, "string 32");
	itc_write(data, 0, "string 33");
	while(itc_read(data, 0, string)) printf("%s\n", string);
	*/
	itc_destroy(&data);
}
