/**
 * \file iri_iif_req.c -- Structure for handling IRI_IIF requests
 * \author Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * \date 2013
 */  

#include <stdlib.h>
#include "iri_iif_req.h"

void iri_iif_q_init(iri_iif_queue_t *q)
{
    q->first = NULL;
    q->end = NULL;
}

int iri_iif_q_empty(iri_iif_queue_t *q)
{
    if (q->first == NULL && q->end == NULL) {
        return 1;
    }
    return 0;
}

int iri_iif_q_get(iri_iif_queue_t *q, iri_iif_req_t *ret)
{ 
    if (q->first != NULL) {
        ret = q->first;
        q->first = q->first->next;
        
        ret->next = NULL;
        return 0;
    }
    return 1;
}

void iri_iif_q_add(iri_iif_queue_t *q, iri_iif_req_t *r)
{
    if (q->first == NULL) {
        q->end = q->first = r;
    } else {
        q->end->next = r;
        q->end = q->end->next;
    }
}

void iri_iif_q_destroy(iri_iif_queue_t *q)
{
    iri_iif_req_t *d = q->first;
    while (d != NULL) {
        q->first = q->first->next;
        free(d);
        d = q->first;
    }

    q->first = q->end = NULL;   
}
