/**
 * \file iri_iif_req.h -- Structure for handling IRI_IIF requests -- header file
 * \author Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * \date 2013
 */

#ifndef IRI_IIF_REQ_H
#define IRI_IIF_REQ_H

#include "filter_types.h"

typedef struct iri_iif_req_s { 
    item_key_t *key;
    uint8_t ip_ver;
    uint32_t rid;
    uint8_t action;
    struct iri_iif_req_s *next;
} iri_iif_req_t;

typedef struct iri_iif_queue_s {
    iri_iif_req_t *first;
    iri_iif_req_t *end;
} iri_iif_queue_t;

void iri_iif_q_init(iri_iif_queue_t *q);
int iri_iif_q_empty(iri_iif_queue_t *q);
int iri_iif_q_get(iri_iif_queue_t *q, iri_iif_req_t *ret);
void iri_iif_q_add(iri_iif_queue_t *q, iri_iif_req_t *r);
void iri_iif_q_destroy(iri_iif_queue_t *q);

#endif
