/*
 * File: sdm_req_queue.h -- queue for SDM requests (header file)
 * Author: Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * Date: 2014
 */
#ifndef SDM_REQ_QUEUE_H
#define SDM_REQ_QUEUE_H

#include "filter_types.h"
#define SDM_Q_SIZE 4096
#define SDM_BATCH_SIZE 2048

typedef struct sdm_q_s {
    int max_size;
    int head;
    int end;
    sdm_flow_identifier_t req_array[SDM_Q_SIZE];
} sdm_q_t;

int sdm_q_init(sdm_q_t *q);
sdm_flow_identifier_t sdm_q_pull(sdm_q_t *q);
int sdm_q_push(sdm_q_t *q, sdm_flow_identifier_t *r);
int sdm_q_destroy(sdm_q_t *q);


#endif /* SDM_REQ_QUEUE_H */
