#!/bin/sh

FW_PATH=./combo10g10_30_lidemo.mcs

echo 'Shutting down tsuctl ...'
pkill tsuctl

sleep 1

echo 'Loading sdm firmware ...'
csboot -f 100 $FW_PATH

echo 'Preparing memory ...'
csbus 10104 1
csbus 10204 1

MEM1_STATE=`csbus 10104`
MEM2_STATE=`csbus 10204`
FW_STATE=`csbus 200000c`

if [[ "$MEM1_STATE" == '01000007' && "$MEM2_STATE" == '02000007' 
   && "$FW_STATE" == '00000004' ]]; then
    echo Firmware ready
fi

echo 'Enabling input buffers ...'
ibufctl -Ae1

echo 'Starting tsuctl ...'
if [[ -z `pidof tsuctl` ]]; then
    tsuctl
fi

echo Done
