/*
 * File: ini3d.h -- INI3 daemon for LI HW probe - header file
 * Author: Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * Date: 2013
 */  

#ifndef INI3D_H
#define INI3D_H

#include <stdint.h>

#define INI3BAKFILE "ini3payload.bak"

typedef struct ini3header {
    uint8_t version;
    uint8_t reserved;
    uint32_t probe_id;
}__attribute__ ((__packed__)) ini3header_t;

typedef struct ini3_head {
    uint16_t blob_size;
    uint8_t sze_int;
    uint8_t reserved;
    uint32_t timestamp_sec;
    uint32_t timestamp_ns;
    uint16_t rid[2];
} ini3_head_t;

typedef struct ini3payload {
    load_head_t header;
    unsigned char *data;
} ini3payload_t;

#endif
