#ifndef LOG_READER_H
#define LOG_READER_H

#include <time.h>
#include "msg_types.h"

typedef struct log_reader_s{
    int fds[MOD_COUNT];
    time_t last_logs_ts[MOD_COUNT];
    int min_severity;
} log_reader_t;

int reader_init(log_reader_t *rd, const char *path, int min_severity);
int reader_report(log_reader_t *rd, int module);
void reader_set_min_severity(log_reader_t *rd, int severity);
void reader_destroy(log_reader_t *rd);

#endif /* LOG_READER_H */
