/**
 * \file msg_types.h
 * \brief 
 * \author Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * \version 
 * \date 2015-02-17
 */

#include <stdint.h>

#ifndef MSG_TYPES_H
#define MSG_TYPES_H

#define MOD_COUNT 3

enum msg_type {
    STOP_MSG      =   4,
    START_MSG     =   5,
    REPORT_MSG    =   6,
    MONITOR_MSG   =   7,
    TRANS_END     = 249,
    INT_MODE      = 250,
    SET_RES       = 252,
    STATE_RES_EXT = 253,
    STATE_RES     = 254,
    ERROR_RES     = 255,
};

enum msg_size {
    ERR_SIZE       = 12,
    STATE_SIZE     = 14,
    SET_SIZE       =  9,
};

enum mod_states {
    MOD_DOWN = 0,
    MOD_OK   = 1,
    MOD_LOG  = 2,
    MOD_KILL = 3,
};

typedef struct msg_head_s {
    uint8_t type;
    uint32_t length;
    uint8_t padding[3];
} __attribute__((packed)) msg_head_t;

typedef struct msg_s {
    msg_head_t header;
    void *data;
} msg_t;             

typedef struct start_msg_s {
    char SLIS_CCCI_port[6];
    char SLIS_INI3_port[6];
    char probe_id[13];
    uint8_t SLIS_host_len;
    uint8_t CCCI_TRAP_len;
    uint8_t filterd_TRAP_len;
    uint8_t INI3_TRAP_len;
    uint8_t exe_path_len;
    uint8_t intercepted_ifc;
    char *exe_path_cccid;
    char *exe_path_filterd;
    char *exe_path_filterd_pcap;
    char *exe_path_ini3d;
    char *SLIS_host;
    char *CCCI_TRAP_str;
    char *filterd_TRAP_str;
    char *INI3d_TRAP_str;
} start_msg_t;

typedef struct state_msg_s {
    uint8_t CCCI_state;
    uint8_t filter_state;
    uint8_t INI3_state;
    uint8_t padding[5];
} state_msg_t;

#endif /* MSG_TYPES_H */
